# Generated by Django 2.2.11 on 2020-05-01 14:44
from django.db import connection
from django.db import migrations


def delete_duplicated_objects(apps, schema_editor):
    annotation_object_model = apps.get_model('remo', 'AnnotationObject')

    with connection.cursor() as cursor:
        cursor.execute("""
        SELECT annotation_id, name, count(*)
        FROM annotation_objects
        GROUP BY annotation_id, name
        HAVING count(*) > 1
        """)
        duplicates = cursor.fetchall()
    for annotation_id, obj_name, count in duplicates:
        for _ in range(count - 1):
            duplicate = annotation_object_model.objects.filter(annotation_id=annotation_id, name=obj_name).last()
            duplicate.delete()


class Migration(migrations.Migration):

    dependencies = [
        ('remo', '0004_auto_20200416_0940'),
    ]

    operations = [
        migrations.RunPython(delete_duplicated_objects),
    ]
